///////////////////////////////////////////////////////////////////////////
// Last_Modified : on April. 8,
// 		   try to use one thread for all visualizations, this is 
//		   proper for using one window for visualization.
//		   the parameters should includes:
//		    columns, scaled, scalen, and dataFile
//		   Further improvement should include more parameters, like
//			orientation, font, etc.
// Problem:  flick, due to resize() in initstuff, strange thing is without 
// 	     the resize(), the picture will not show.
///////////////////////////////////////////////////////////////////////////
 
import java.awt.*;
import java.applet.*;
import java.io.*;
import java.lang.*;
import java.net.*;
import java.util.*;

class VisualTime extends Canvas implements Runnable {
 
    static final int    VERTICAL = 0;
    static final int    HORIZONTAL = 1;
//    static boolean      runflag = true; 
    static final int    SOLID = 0;
    static final int    STRIPED = 1;
    static final Color  Colors[] = {Color.red, Color.green, Color.blue, 
		Color.pink, Color.orange, Color.magenta, Color.cyan, 
		Color.white, Color.yellow, Color.gray, Color.darkGray};
    static boolean die = false; 
    static long delta = 0; 
    Thread animator;
    static int currType = 0;
    static int visualType = 0; // 0 for time consuming
			// 1 for load info on sun machine
			// 2 for load info on solaris machine
			// 3 for load info on IBM
			// etc.
    int                 orientation;
    String              title;
    String              dataFile;
    Font                titleFont;
    FontMetrics         titleFontMetrics;
    int                 titleHeight = 15;
    int                 columns;
    int                 values[];
    String              valStr[];
    Object              colors[];
    Object              labels[];
    int                 styles[];
    int                 scalen = 10;
    int                 scaled = 1;
    float		scaler;
    float               scalef = Float.valueOf("10.0").floatValue();
    int                 maxLabelWidth = 10;
    int                 barWidth;
    int                 barSpacing = 10;
    static int          max = 0;
    Applet		Aparent;
//    VisualWin		parent;
    Frame               parent;
    String JevServHost;           // the host name Jeeves Server runs on
    String PortNo;                // the socket Port No. Jeeves Server uses
    int Wwidth, Wheight;
    static boolean first = true;
    String userID, applID;
    String repIP, repPort, repDBA;
    long startTime = 0;
    boolean keeprun = true;
    static int draw_count = 0;
 
    public VisualTime(Frame father, Applet Aplparent, String hostname, String portno,
		      String userID, String applID, long startTime, boolean flag,
		      String repIP, String repPort, String repDBA) {
   	keeprun = flag;	
        JevServHost = hostname;
        PortNo      = portno;
	this.userID = userID;
	this.applID = applID;
  	this.repIP  = repIP;
	this.repPort = repPort;
	this.repDBA  = repDBA;
	this.startTime = startTime;
        animator = new Thread("visualtime");
	parent   = father;
	Aparent  = Aplparent;
	currType = visualType;
    }
 
    public synchronized void paint(Graphics g) {
        int i,j;
        int cx,cy;

	Wwidth  = parent.size().width;
	Wheight = parent.size().height - 80;
	if ((size().width != Wwidth) || (size().height != Wheight)) {
	    resize(Wwidth, Wheight);
	 }
	validate();
        // draw the title centered at the bottom of the bar graph
	scaler = max / (Wheight-2*titleFont.getSize() - 80) + 1;
        g.clearRect(0, 0, Wwidth, Wheight);
        g.setColor(Color.black);
        i = titleFontMetrics.stringWidth(title);
        g.setFont(titleFont);
//        g.drawRect(0, 0, Wwidth-2, Wheight-1 );
        g.drawLine(barSpacing, 0, barSpacing, Wheight-2*titleFont.getSize());
        g.drawLine(barSpacing, Wheight-2*titleFont.getSize(),
                   Wwidth, Wheight-2*titleFont.getSize());
	
        for (i=0; i < columns + 1; i++) {
            Float tmp = new Float(values[i] / scaler);
            switch (orientation) {
              case VERTICAL:
              default:
                 // set the next X coordinate to account for the label
                 // being wider than the bar size().width.
                 cx = (Math.max((barWidth + barSpacing),maxLabelWidth) * i) + barSpacing;
  
                 // center the bar chart
                 cx += Math.max((Wwidth - ((columns+1) * (barWidth + (2 * barSpacing))))/2,0);
 
                 // set the next Y coordinate to account for the size().height
                 // of the bar as well as the title and labels painted
                 // at the bottom of the chart.
                 cy = Wheight - (tmp.intValue()) - 1 - (2 * titleFont.getSize());

                 // draw the label
                     g.setColor(Color.black);
                     g.drawString((String)labels[i], cx, Wheight - titleFont.getSize() - titleFontMetrics.getDescent() + 10);

                 // draw the shadow bar
                 if (colors[i] == Color.black) {
                     g.setColor(Color.gray);
                 }
                 g.fillRect(cx + 5, cy - 3, barWidth,  (tmp.intValue()));
                 // draw the bar with the specified color
                 g.setColor((Color)(colors[i]));
                 switch (styles[i]) {
                    case SOLID:
                         default:
                         g.fillRect(cx, cy, barWidth, (tmp.intValue()));
                        break;
                    case STRIPED: {
                        int steps = (tmp.intValue()) / 2;
                        int ys;
 
/*                        for (j=0; j < steps; j++) {
                            ys = cy + (2 * j);
                            g.drawLine(cx, ys, cx + barWidth, ys);
                        }
*/
                    }
                    break;
                }
                g.setColor(Color.black);
                g.drawString(valStr[i], cx, cy - titleFontMetrics.getDescent()-1);
                break;
              case HORIZONTAL:
                 //set the Y coordinate
                 cy = ((barWidth + barSpacing) * i) + barSpacing;
 
                // set the X coordinate to be the size().width of the widest
                // label
                cx = maxLabelWidth + 1;
                cx += Math.max((Wwidth - (maxLabelWidth + 1 + titleFontMetrics.stringWidth("" + max) + (max * scalen/scaled))) / 2, 0);
                // draw the labels and the shadow
                g.setColor(Color.black);
                g.drawString((String)labels[i], cx - maxLabelWidth - 1, cy + titleFontMetrics.getAscent());
                if (colors[i] == Color.black) {
                    g.setColor(Color.gray);
                }
                g.fillRect(cx + 3, cy + 5, (tmp.intValue()), barWidth);
                // draw the bar in the current color
                g.setColor((Color)(colors[i]));
                switch (styles[i]) {
                  case SOLID:
                       default:
                    g.fillRect(cx, cy, (tmp.intValue()), barWidth);
                    break;
                  case STRIPED: {
                        int steps = (tmp.intValue()) / 2;
                        int ys;
                        for (j=0; j < steps; j++) {
                            ys = cx + (2 * j);
//                            g.drawLine(ys, cy, ys, cy + barWidth);
                        }
                    }
                    break;
                }
                g.drawString("" + valStr[i], cx + (tmp.intValue())+ 3, cy + titleFontMetrics.getAscent());
 
                break;
            } 
       }
    }
 
    public void start() {
//	animator = new Thread(this);
        if (animator.isAlive()) {
            animator.resume();
        } else {
            animator.start();
        }
	validate();
   	show();
        initstuff();
    }
 
    public void stop() {
        animator.suspend();
    }
 
    public void destroy() {
        animator.stop();
    }
 
    public void run() {
           initstuff();
       while (true) {
	   if (die)
	       break;
           readvals();
	   paint(getGraphics());
           try {
               Thread.sleep(2500);
           } catch (InterruptedException e) { }
           if (! keeprun) {
  	      draw_count ++;
	      if (draw_count > 5) {
	         draw_count = 0;
	         die = true;
	       }
            }
        }
    }
 
    public void initstuff() {
	String param = null;
 
	titleFont = new Font("TimesRoman", Font.BOLD, 14);
	titleFontMetrics = getFontMetrics(titleFont);

        String str = "http://" + JevServHost + ":" + PortNo;

	if (visualType == 0) {
 	    title = "Execution Time of Each Tasks In the Application";
	    param = Aparent.getParameter("TIMEdataF");
	    if (param == null)
	        dataFile = str + "/result/time.dat";
	    else {
		if (keeprun) {
		    dataFile = str + param + "?userID=" + userID 
			 + "&applID=" + applID + "&totalExecFlag=true";
		// not reading total exec time, June 25 
		 }
		else {
		    dataFile = str + param + "?userID=" + userID 
			 + "&applID=" + applID + "&totalExecFlag=false";
		 }
		dataFile += "&DrepIP=" + repIP + "&DrepPort=" + repPort 
			 + "&DrepDBA=" + repDBA;
	     }
 	    param = Aparent.getParameter("time_scalen");
	    if (param == null)
		scalen = 1;
	    else 
		scalen = Integer.parseInt(param);
 	    param = Aparent.getParameter("time_scaled");
	    if (param == null)
		scaled = 20;
	    else 
		scaled = Integer.parseInt(param);
	 }
 
        orientation = VERTICAL;

        readvals();

        for (int i=0; i < columns + 1; i++) {
//        for (int i=0; i < columns; i++) {
            //parse the label for this column
            maxLabelWidth = Math.max(titleFontMetrics.stringWidth((String)(labels[i])), maxLabelWidth);
 
            // parse the bar style

            styles[i] = SOLID;
            colors[i] = Colors[i];
         }   //for loop

        switch (orientation) {
          case VERTICAL:
          default:
            barWidth = maxLabelWidth;
            break;
 
          case HORIZONTAL:
            barWidth = titleFont.getSize();
            resize(Math.max((max * scalen/scaled) + titleFontMetrics.stringWidth("" + max), titleFontMetrics.stringWidth(title)) + maxLabelWidth + 5, ((columns+1) * (barWidth + barSpacing)) + titleFont.getSize() + 10);
            break;
         }
    }
 
    public void readvals() {
      InputStream file = null; 
      DataInputStream dis = null;
      URL url = null;
      String line;
      String line1;
      int i = -1;

//    Process p = Runtime.getRuntime().exec("rm -r file");
//    this needs a servlet, applet has no authorization for that, April.9,1:00am
//    File ff("filename");
//    if (ff.exists())
 
      try {
          url = new URL(dataFile);
       }  catch (MalformedURLException e1) {
          System.out.println("ERROR in: invoking servlet TimeVisual");
        }

      try {
          dis = new DataInputStream(url.openStream());
       }  catch (IOException e1) {
          System.out.println("ERROR in: open stream of servlet TimeVisual");
        }

      try {
	while ((line = dis.readLine()) == null);
   	columns = Integer.parseInt(line);

        values = new int[columns + 1];
        valStr = new String[columns + 1];
        colors = new Color[columns + 1];
        labels = new String[columns + 1];
        styles = new int[columns + 1];

	for (i = 0; i < columns + 1; i ++)
	     colors[i] = Colors[i];

	i = -1;
	int lines;
	if (keeprun)
	    lines = columns;
	else
	    lines = columns + 1; // including total exec time record
        while ((++i < lines) && (line = dis.readLine()) != null ) {
             try {
                labels[i] = line.substring(0, line.lastIndexOf(" "));
                line1 = line.substring(line.lastIndexOf(" "));
                valStr[i] = line1;
                line1 = line1.concat(".0");
                values[i] = (new Float(Float.valueOf(line1).floatValue()*scalen/scaled)).intValue();
              } catch (NumberFormatException e) {
                       values[i] = 0;
		       System.out.println("Wrong number format of exec time");
                }
             if (values[i] > max) {
                 max = values[i];
              }
         }
        dis.close();
      } catch (IOException e) {
           e.printStackTrace();
        }

     labels[columns] = "Total";
     styles[columns] = SOLID;
     if (keeprun) {
         valStr[columns] = Long.toString(delta) + " ms";
         values[columns] = (new Float(delta * scalen / scaled)).intValue(); 
      }
     if (values[columns] > max)
         max = values[columns];

     if (keeprun) {
         Date currDate = new Date();
         long currTime = currDate.getTime();
         delta    = currTime - startTime;
         valStr[columns] = Long.toString(delta) + " ms";
         values[columns] = (new Float(delta * scalen / scaled)).intValue(); 
	 if (values[columns] > max)
	     max = values[columns];
      }
  }	// end of readvals()
}
